////////////////////////////////////////////////////////////////
//
// Copyright (C) 2005 Affymetrix, Inc.
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License (version 2) as 
// published by the Free Software Foundation.
// 
// This program is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
// General Public License for more details.
// 
// You should have received a copy of the GNU General Public License 
// along with this program;if not, write to the 
// 
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//
////////////////////////////////////////////////////////////////

#include <iostream>
#include <stdlib.h>

#include "util/CalvinChpCheck.h"

using namespace std;

int main(int argc, char *argv[]) {
  if(argc != 3) {
    cout << "usage: " << endl;
    cout << "   cc-chp-compare test.chp gold.chp" << endl;
    exit(0);
  }
  vector<string> test, gold;
  test.push_back(argv[1]);
  gold.push_back(argv[2]);
  cout << "Getting ready to check. " << endl;
  CalvinChpCheck checker(test, gold, 0.001, 2, true, "affymetrix-algorithm-param-");
  string msg;
  if(!checker.check(msg))
    cout << "File not equivalent!!! " << msg << endl;
  else
    cout << "Files equivalent." << endl;
  return 0;
}
